#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Container::UESFolder
  private_class_method :new

  BEFOLDER_CODE = Java::cz.ues.core.container.UESFolder::BEFOLDER_CODE #:nodoc:

  # URI of folder business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_FOLDER = Java::cz.ues.core.container.UESFolder::BETYPE_FOLDER


# Creates a folder of class Folder. Command creates new folder in specified container. At the very least meta artifact must be specified
# in UESArtifactCreate DTO. Competent role for artifact will be selected as the most suitable according to specified container
# and meta artifact (executive/authorized role with connected interface), or can be also specified in UESArtifactCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where folder will be created.
# 
# <tt><b>param</b></tt> folder DTO containing attributes of the new folder
# 
# <tt><b>return</b></tt> UESURI of the created folder
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(locationUri, folder = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    folder = Ues::Core::Container::UESFolderCreate.new(folder).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.create(locationUri, folder)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Reads folder specified by the <code>folderUri</code> attribute and returns its attributes.
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder
# 
# <tt><b>return</b></tt> DTO with folder attributes
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttributes(folderUri)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.getAttributes(folderUri)
    if (_r != nil) then _r = Ues::Core::Container::UESFolderAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESFolder
    alias attributes getAttributes
  end

# This command returns a list of entries (artifacts or shortcuts) enlisted in the specified folder (entity type of main entity of the
# command could be a Folder, Organizational Unit, Territory or Meta Model Dictionary). Command does not return all entries, only a
# sublist. The list of returned entries could be filtered by the name, code or type of an entry. The list is sorted by the name (and
# codes in case are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the filtering or
# these attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder from where entries (artifacts or shortcuts) are listed. It could be a Folder, Organizational
# Unit, Territory or Meta Model Dictionary.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing shortcuts
# 
# <tt><b>return</b></tt> List of DTO representing folder entries (artifacts or shortcuts).
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES6-02
# 
# <tt><b>Deprecated</b></tt> Deprecated since UES7-01. Use #getEntryList(UESURI, UESFolderGetEntryList) getEntryList to get a list of entries.
  def self.getFolderEntryList(folderUri, criteria = nil)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    criteria = Ues::Core::Container::UESFolderGetFolderEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.getFolderEntryList(folderUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESFolder
    alias folder_entry_list getFolderEntryList
  end

# This command returns a list of entries (artifacts or shortcuts) enlisted in the specified folder (entity type of main entity of the
# command could be a Folder, Organizational Unit, Territory or Meta Model Dictionary). Command does not return all entries, only a
# sublist. The list of returned entries could be filtered by the name, code or type of an entry. The list is sorted by the name (and
# codes in case are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the filtering or
# these attributes combinations.
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder from where entries (artifacts or shortcuts) are listed. It could be a Folder, Organizational
# Unit, Territory or Meta Model Dictionary.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing shortcuts. Available parameters are:
# cz.ues.core.container.dto.UESFolderEntryAttributes#name name,
# cz.ues.core.container.dto.UESFolderEntryAttributes#code code and
# cz.ues.core.container.dto.UESFolderEntryAttributes#type type : cz.ues.core.container.dto.UESFolderEntryType
# UESFolderEntryType.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing folder entries (artifacts or shortcuts).
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES7-01
  def self.getEntryList(folderUri, criteria = nil)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    criteria = Ues::Core::Container::UESFolderGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.getEntryList(folderUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESFolder
    alias entry_list getEntryList
  end

# This command deletes the specified folder from the system. The folder is deleted even if it contains a locked sheet or attachment. The
# folder cannot be deleted when:
# 
# 
# * the folder is not empty.
# 
# * the folder's workflow is not created
# 
# * a property contains a reference to this folder
# 
# * a time sheet exists with a reference to this folder
# 
# 
# 
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(folderUri)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.delete(folderUri)
    
    return _r
  end

# Command for setting attributes of a folder. The command can't modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder whose attributes are to be changed.
# 
# <tt><b>param</b></tt> folder DTO containing new attributes the folder.
# 
# <tt><b>return</b></tt> UESURI of the folder whose attributes are to be changed.
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES7-01
  def self.setAttributes(folderUri, folder = nil)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    folder = Ues::Core::Container::UESFolderSetAttributes.new(folder).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.setAttributes(folderUri, folder)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESFolder
    alias set_attributes setAttributes
  end

# The command exports a folder to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is why it
# returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder to export
# 
# <tt><b>param</b></tt> folder DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.export(folderUri, folder = nil)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    folder = Ues::Core::Container::UESFolderExport.new(folder).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.export(folderUri, folder)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported folder.
# 
# <tt><b>param</b></tt> folderUri UESURI of the folder we want to get the exported file from.
# 
# <tt><b>param</b></tt> folder DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported folder.
# 
# <tt><b>throws</b></tt> UESFolderRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(folderUri, folder = nil)
    folderUri = Ues::Core::Commons::Uri::UESURI.new(folderUri).to_java
    folder = Ues::Core::Container::UESFolderGetExportData.new(folder).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolder.java_class)
    _r = _s.getExportData(folderUri, folder)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESFolder
    alias export_data getExportData
  end
end
