#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES7-10
class Ues::Core::Container::UESMetaModel
  private_class_method :new

  BEMETAMODEL_CODE = Java::cz.ues.core.container.UESMetaModel::BEMETAMODEL_CODE #:nodoc:

  # URI of organizational unit business entity
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_METAMODEL = Java::cz.ues.core.container.UESMetaModel::BETYPE_METAMODEL


# Creates a new meta model. The command creates a new meta model in a specified location. At the very least meta artifact and name must
# be specified in UESMetaModelCreate DTO. Competent role for the meta model will be selected as the most suitable according to
# specified container and meta artifact (executive/authorized role with connected interface), or can be also specified in
# UESMetaModelCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where meta model will be created.
# 
# <tt><b>param</b></tt> metaModel DTO containing attributes of the new meta model.
# 
# <tt><b>return</b></tt> UESURI of the new meta model.
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, metaModel = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    metaModel = Ues::Core::Container::UESMetaModelCreate.new(metaModel).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.create(locationUri, metaModel)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the meta model specified by the metaModelUri parameter. The command does not change the
# state of the meta model in the system.
# 
# <tt><b>param</b></tt> metaModelUri UESURI of a meta model whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the meta model attributes
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(metaModelUri)
    metaModelUri = Ues::Core::Commons::Uri::UESURI.new(metaModelUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.getAttributes(metaModelUri)
    if (_r != nil) then _r = Ues::Core::Container::UESMetaModelAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESMetaModel
    alias attributes getAttributes
  end

# Command for setting attributes of a meta model. The command can't modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> metaModelUri UESURI of the meta model whose attributes are to be changed
# 
# <tt><b>param</b></tt> metaModel DTO containing new attributes the meta model
# 
# <tt><b>return</b></tt> UESURI of the meta model
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(metaModelUri, metaModel = nil)
    metaModelUri = Ues::Core::Commons::Uri::UESURI.new(metaModelUri).to_java
    metaModel = Ues::Core::Container::UESMetaModelSetAttributes.new(metaModel).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.setAttributes(metaModelUri, metaModel)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESMetaModel
    alias set_attributes setAttributes
  end

# This command deletes the specified meta model from the system. The meta model is deleted even if it contains a locked sheet or
# attachment. The meta model cannot be deleted when:
# 
# 
# * the meta model is not empty.
# 
# * the meta model's workflow is not created
# 
# * a property contains a reference to this meta model
# 
# * a time sheet exists with a reference to this meta model
# 
# 
# 
# 
# <tt><b>param</b></tt> metaModelUri UESURI of the meta model which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.delete(metaModelUri)
    metaModelUri = Ues::Core::Commons::Uri::UESURI.new(metaModelUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.delete(metaModelUri)
    
    return _r
  end

# This command returns a list of entries (artifacts, meta artifacts, meta interfaces, containers, meta model dictionaries or shortcuts)
# enlisted in the specified meta model dictionary. Command does not return all entries, only a sublist. The list of returned entries
# could be filtered by the name, code or entityTypeUri of an entry. The list is sorted by the name (and codes in case are equal) of a
# entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the filtering or these attributes combinations.
# 
# <tt><b>param</b></tt> metaModelUri UESURI of the meta model dictionary from where entries are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria. Available parameters are: cz.ues.core.container.dto.UESMetaModelEntryAttributes#name
# name, cz.ues.core.container.dto.UESMetaModelEntryAttributes#code code and
# cz.ues.core.container.dto.UESMetaModelEntryAttributes#entityTypeUri entityTypeUri.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing meta model dictionary entries.
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getEntryList(metaModelUri, criteria = nil)
    metaModelUri = Ues::Core::Commons::Uri::UESURI.new(metaModelUri).to_java
    criteria = Ues::Core::Container::UESMetaModelGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.getEntryList(metaModelUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESMetaModel
    alias entry_list getEntryList
  end

# The command exports a meta model to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is why
# it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> metaModelUri UESURI of the meta model to export
# 
# <tt><b>param</b></tt> metaModel DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.export(metaModelUri, metaModel = nil)
    metaModelUri = Ues::Core::Commons::Uri::UESURI.new(metaModelUri).to_java
    metaModel = Ues::Core::Container::UESMetaModelExport.new(metaModel).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.export(metaModelUri, metaModel)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported meta model.
# 
# <tt><b>param</b></tt> metaModelUri UESURI of the meta model we want to get the exported file from.
# 
# <tt><b>param</b></tt> metaModel DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported meta model.
# 
# <tt><b>throws</b></tt> UESMetaModelRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(metaModelUri, metaModel = nil)
    metaModelUri = Ues::Core::Commons::Uri::UESURI.new(metaModelUri).to_java
    metaModel = Ues::Core::Container::UESMetaModelGetExportData.new(metaModel).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESMetaModel.java_class)
    _r = _s.getExportData(metaModelUri, metaModel)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESMetaModel
    alias export_data getExportData
  end
end
