#--
# This code is automatically generated, do not modify the content !!!
#++
# Service for accessing images from uuOS image catalog.
# 
# <tt><b>since</b></tt> UES8-17
class Ues::Core::Imagecatalog::UESImageCatalog
  private_class_method :new


# Returns list of images from uuOS catalog. By default, the list is sorted by
# image names (and codes in case names are equal). The list can be filtered
# using "query" parameter in criteria using uuQuery 2.0 syntax.
# 
# <tt><b>param</b></tt> artifactUri UESURI of an artifact for which images are to be listed.
# 
# <tt><b>param</b></tt> criteria Object containing criteria for listing images. Available
# parameters for query are:
# cz.ues.core.imagecatalog.dto.UESImageCatalogImageEntryAttributes#name
# name and
# cz.ues.core.imagecatalog.dto.UESImageCatalogImageEntryAttributes#code
# code.
# 
# <tt><b>return</b></tt> List of images from uuOS catalog fullfilling given criteria.
# 
# <tt><b>throws</b></tt> UESImageCatalogRTException
# 
# <tt><b>see</b></tt> <a target="_blank" href=
# "https://plus4u.net/ues/sesm?SessFree=ues:UNI-BT:UU.OS%2FQUERY-2.0">
# uuQuery 2.0</a>
# 
# <tt><b>since</b></tt> UES8-17
  def self.getImageList(artifactUri, criteria = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    criteria = Ues::Core::Imagecatalog::UESImageCatalogGetImageList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.imagecatalog.UESImageCatalog.java_class)
    _r = _s.getImageList(artifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Imagecatalog::UESImageCatalog
    alias image_list getImageList
  end
end
