#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES8-14
class Ues::Core::Role::UESBasicGroup
  private_class_method :new

  BE_BASIC_GROUP_CODE = Java::cz.ues.core.role.UESBasicGroup::BE_BASIC_GROUP_CODE #:nodoc:

  # URI of basic group business entity.
# 
# <tt><b>since</b></tt> UES8-14
  BETYPE_BASICGROUP = Java::cz.ues.core.role.UESBasicGroup::BETYPE_BASICGROUP


# Creates a new basic group in a specified location. If the meta artifact is not selected in UESBasicGroupCreate, the new basic group
# is created by Basic Group meta artifact from uuOS application. Competent role for the new basic group is always the same role as the competent
# role for the organizational unit of newly created basic group.
# 
# <tt><b>param</b></tt> locationUri locationUri UESURI of the folder / organizational unit / uuApp meta model where the basic group will be created.
# 
# <tt><b>param</b></tt> basicGroup Object containing the attributes of the basic group.
# 
# <tt><b>return</b></tt> UESURI of the newly created basic group.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.create(locationUri, basicGroup = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    basicGroup = Ues::Core::Role::UESBasicGroupCreate.new(basicGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.create(locationUri, basicGroup)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes representing the basic group specified by the basic_group_uri parameter. The command does not change
# the state of the basic group in the system.
# 
# <tt><b>param</b></tt> basicGroupUri UESURI of the basic group whose attributes will be returned.
# 
# <tt><b>return</b></tt> Object containing the attributes of specified basic group.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.getAttributes(basicGroupUri)
    basicGroupUri = Ues::Core::Commons::Uri::UESURI.new(basicGroupUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.getAttributes(basicGroupUri)
    if (_r != nil) then _r = Ues::Core::Role::UESBasicGroupAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESBasicGroup
    alias attributes getAttributes
  end

# Command for setting attributes of a basic group. The command cannot modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> basicGroupUri UESURI of the basic group whose attributes will be modified.
# 
# <tt><b>param</b></tt> basicGroup Object containing the changed attributes of the basic group.
# 
# <tt><b>return</b></tt> UESURI of the basic group.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.setAttributes(basicGroupUri, basicGroup = nil)
    basicGroupUri = Ues::Core::Commons::Uri::UESURI.new(basicGroupUri).to_java
    basicGroup = Ues::Core::Role::UESBasicGroupSetAttributes.new(basicGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.setAttributes(basicGroupUri, basicGroup)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESBasicGroup
    alias set_attributes setAttributes
  end

# Deletes the specified basic group role from the system. The basic group is deleted even if it contains a locked sheet or attachment.
# The basic group cannot be deleted if: the basic group is in an active cast, the basic group's workflow is not created, a property
# contains a reference to this basic group, a time sheet exists with a reference to this basic group,
# the basic_group_type attribute's value is "AUTHORITIES" or "AUDITORS".
# 
# <tt><b>param</b></tt> basicGroupUri UESURI of UESURI of the basic group which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.delete(basicGroupUri)
    basicGroupUri = Ues::Core::Commons::Uri::UESURI.new(basicGroupUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.delete(basicGroupUri)
    
    return _r
  end

# Creates new artifact interface connection to the specified role.
# 
# <tt><b>param</b></tt> basicGroupUri UESURI of the basic group where the artifact interface will be connected.
# 
# <tt><b>param</b></tt> artifactInterface Object containing the artifact interface code that is to be connected.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.addArtifactInterface(basicGroupUri, addArtifactInterface = nil)
    basicGroupUri = Ues::Core::Commons::Uri::UESURI.new(basicGroupUri).to_java
    addArtifactInterface = Ues::Core::Role::UESBasicGroupAddArtifactInterface.new(addArtifactInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.addArtifactInterface(basicGroupUri, addArtifactInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESBasicGroup
    alias add_artifact_interface addArtifactInterface
  end

# Removes role interface connection from the specified group role. Only connected interfaces can be disconnected from the group role.
# 
# <tt><b>param</b></tt> basicGroupUri UESURI of the basic group where the artifact interface will be disconnected.
# 
# <tt><b>param</b></tt> artifactInterface Object containing the artifact interface code that is to be disconnected.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.removeArtifactInterface(basicGroupUri, removeArtifactInterface = nil)
    basicGroupUri = Ues::Core::Commons::Uri::UESURI.new(basicGroupUri).to_java
    removeArtifactInterface = Ues::Core::Role::UESBasicGroupRemoveArtifactInterface.new(removeArtifactInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.removeArtifactInterface(basicGroupUri, removeArtifactInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESBasicGroup
    alias remove_artifact_interface removeArtifactInterface
  end

# Returns sorted list of the codes of artifact interfaces that are connected to the specified basic group.
# 
# <tt><b>param</b></tt> basicGroupUri UESURI of the basic group for which the codes of connected artifact interfaces are to be listed.
# 
# <tt><b>return</b></tt> The list of objects containing the codes of artifact interfaces.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTExceptionr
# 
# <tt><b>since</b></tt> UES8-14
  def self.getArtifactInterfaceList(basicGroupUri)
    basicGroupUri = Ues::Core::Commons::Uri::UESURI.new(basicGroupUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.getArtifactInterfaceList(basicGroupUri)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESBasicGroup
    alias artifact_interface_list getArtifactInterfaceList
  end

# Returns list of the basic groups which are located in the organizational unit of specified artifact. The list of the returned basic groups can
# be filtered and ordered arbitrarily. The parameters available for customized filtering and ordering are the following:
# name, code, basic_group_type. The list is sorted by name of the basic group by default.
# 
# <tt><b>param</b></tt> artifactUri UESURI of an existing artifact. Basic groups from the organizational unit where the artifact is located will be returned.
# 
# <tt><b>return</b></tt> The list of basic groups which are located in the same organizational unit as specified artifact.
# 
# <tt><b>throws</b></tt> UESBasicGroupRTException
# 
# <tt><b>since</b></tt> UES8-14
  def self.getBasicGroupList(artifactUri, criteria = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    criteria = Ues::Core::Role::UESBasicGroupGetBasicGroupList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESBasicGroup.java_class)
    _r = _s.getBasicGroupList(artifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESBasicGroup
    alias basic_group_list getBasicGroupList
  end
end
