#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-10
class Ues::Core::Role::UESCast
  private_class_method :new


# Casts a subject (role or group) to another subject (role or group). Only roles and groups from the same territory are supported at the
# moment (therefore it is not possible to cast across territories and form pseudo business access role relation at the moment). Cast is
# not an entity, it is a relation between 2 subjects (and these 2 subjects identify the relation).
# 
# 
# 
# <table>
# <caption>Note that only some combinations of subjects in a cast relation are permitted: </caption>
# <tr>
# <td></td>
# <td>
# <table border="1">
# <tr>
# <th colspan=3>casted subject</br> (castedSubjectUri DTO parameter type)</th>
# </tr>
# <tr width="100%" align="center">
# <td width="33%">ROLE</td>
# <td width="33%">GROUP</td>
# <td width="33%">ACCESS ROLE</td>
# </tr>
# </table>
# </td>
# </tr>
# <tr>
# <td>
# <table width="100%" border="1">
# <tr>
# <th rowspan="3">the subject to which the subject from DTO</br> is casted (main entity type)</th>
# <td align="center">ROLE</td>
# </tr>
# <tr>
# <td align="center">GROUP</td>
# </tr>
# <tr>
# <td align="center">ACCESS ROLE</td>
# </tr>
# </table>
# </td>
# <td>
# <table border="1" width="100%">
# <tr align="center">
# <td>YES</td>
# <td>NO</td>
# <td>YES</td>
# </tr>
# <tr align="center">
# <td>YES</td>
# <td>YES</td>
# <td>YES</td>
# </tr>
# <tr align="center">
# <td>NO</td>
# <td>NO</td>
# <td>NO</td>
# </tr>
# </table>
# </td>
# </tr>
# </table>
# 
# 
# <tt><b>param</b></tt> subjectUri UESURI of the subject into which another subject is casted
# 
# <tt><b>param</b></tt> cast DTO containing attributes of the cast
# 
# <tt><b>throws</b></tt> UESCastRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.create(subjectUri, cast = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    cast = Ues::Core::Role::UESCastCreate.new(cast).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.create(subjectUri, cast)
    
    return _r
  end

# This command returns attributes of one cast. Cast is identified by 2 subjects. The main entity (a subject to which the other is casted)
# and parameter castedSubjectUri in the DTO (the casted subject).
# 
# <tt><b>param</b></tt> subject Uri UESURI of the subject to which the other is casted
# 
# <tt><b>param</b></tt> subject DTO containing ues uri of the casted subject
# 
# <tt><b>return</b></tt> DTO containing the cast attributes
# 
# <tt><b>throws</b></tt> UESCastRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.getAttributes(subjectUri, subject = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    subject = Ues::Core::Role::UESCastGetAttributes.new(subject).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.getAttributes(subjectUri, subject)
    if (_r != nil) then _r = Ues::Core::Role::UESCastAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESCast
    alias attributes getAttributes
  end

# The command returns casts to the specified subject (role or group). The list of returned casts can be filtered by the name and code of
# casted subjects, by the cast level, by the primary cast flag, by the cast state, by the date of creation of the cast and by the cast
# direction. The list is sorted by the date of creation of a cast by default and due to backwards compatibility are returned only casts
# with cz.ues.core.role.dto.UESCastDirection#IN by default, or it can be sorted arbitrarily by any of cast attributes usable for the filtering or these
# attributes combinations.
# 
# <tt><b>param</b></tt> subjectUri UESURI of the subject to which the casts are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing casts. Available parameters are: UESCastAttributes#castedSubjectName
# castedSubjectName, UESCastAttributes#castedSubjectCode castedSubjectCode, UESCastAttributes#dateFrom dateFrom
# , UESCastAttributes#state state : UESCastState UESCastState, UESCastAttributes#level level :
# UESCastLevel UESCastLevel, UESCastAttributes#primary primary, UESCastAttributes#castDirection
# castDirection.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing casts to the subjectUri
# 
# <tt><b>throws</b></tt> UESCastRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.getCastList(subjectUri, criteria = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    criteria = Ues::Core::Role::UESCastGetCastList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.getCastList(subjectUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESCast
    alias cast_list getCastList
  end

# Returns list of access roles (personal access roles and uuEEs) casted directly or indirectly to the specified
# subject (role or group). The list is sorted by the casted subject name and subsequently by casted subject code
# by default.
# 
# <tt><b>param</b></tt> subjectUri UESURI of the subject into which the personal access roles are casted.
# 
# <tt><b>param</b></tt> criteria Object containing paging and filtering criteria. Available parameters are:
# UESCastAccessRoleAttributes#castedSubjectName castedSubjectName
# and UESCastAccessRoleAttributes#castedSubjectCode castedSubjectCode.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of access roles casted to the specified subject. Contains instances of UESAccessRoleCastAttributes.
# 
# <tt><b>throws</b></tt> UESCastRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getAccessRoleCastList(subjectUri, criteria = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    criteria = Ues::Core::Role::UESCastGetAccessRoleCastList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.getAccessRoleCastList(subjectUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESCast
    alias access_role_cast_list getAccessRoleCastList
  end

# Sets basic attributes of the cast. Cast is not an entity, it is a relation between 2 subjects (and these 2 subjects identify the
# relation).
# 
# <tt><b>param</b></tt> subjectUri UESURI of the subject into which another subject is casted
# 
# <tt><b>param</b></tt> cast DTO containing attributes of the cast
# 
# <tt><b>since</b></tt> UES6-10
  def self.setAttributes(subjectUri, cast = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    cast = Ues::Core::Role::UESCastSetAttributes.new(cast).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.setAttributes(subjectUri, cast)
    
    return _r
  end
  class << Ues::Core::Role::UESCast
    alias set_attributes setAttributes
  end

# This command deletes the cast from the system. Any change of user authorization resulting from the cast modification will take effect
# approximately after 15 minutes. The last active executive cast cannot be deleted when this role has an active assistence or guest cast
# (active casts of these types cannot exist without at least one active executive cast). The last active executive cast for this role
# cannot be deleted when the role is competent for at least one artifact (a role without an active cast cannot be competent for any
# artifacts).
# 
# <tt><b>param</b></tt> subjectUri UESURI of the subject to which the other is casted.
# 
# <tt><b>param</b></tt> subject DTO containing UESURI of the casted subject.
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(subjectUri, subject = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    subject = Ues::Core::Role::UESCastDelete.new(subject).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.delete(subjectUri, subject)
    
    return _r
  end

# Checks the cast existence of a subject (access role, role or group) to another subject (role or group) specified in subjectUri.
# The cast subject is identified either by UESURI or by Universe ID of a user whose access role is cast to subjectUri.
# Only the existence of a direct cast is checked by default. The existence of an indirect cast can be checked only between
# an access role (identified either by UESURI or by Universe ID) and another subject (role or group).
# 
# <tt><b>param</b></tt> subjectUri UESURI of the subject to which the other is cast.
# 
# <tt><b>param</b></tt> cast DTO containing cast exists parameters.
# 
# <tt><b>return</b></tt> True if cast exists, else false.
# 
# <tt><b>throws</b></tt> UESCastRTException
  def self.exists(subjectUri, cast = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    cast = Ues::Core::Role::UESCastExists.new(cast).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.exists(subjectUri, cast)
    
    return _r
  end

# Verifies the cast existence of an access role (specified by UESURI or UID) to a list of subjects in a given territory.
# 
# <tt><b>param</b></tt> territoryUri UESURI of a territory where the access role and subjects are located in.
# 
# <tt><b>param</b></tt> criteria  Object containing the access role attributes and a list of subjects.
# 
# <tt><b>return</b></tt> List of subjects with an existing cast.
# 
# <tt><b>throws</b></tt> UESCastRTException
  def self.verifyCastExistence(territoryUri, criteria = nil)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    criteria = Ues::Core::Role::UESCastVerifyCastExistence.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.verifyCastExistence(territoryUri, criteria)
    if (_r != nil) then _t = []; _r.to_a.each do |_e|; if (_e != nil) then _e = Ues::Core::Commons::Uri::UESURI.new(_e) end; _t << _e; end; _r = _t; end;
    return _r
  end
  class << Ues::Core::Role::UESCast
    alias verify_cast_existence verifyCastExistence
  end

# Returns a cast history list leading in the subject and/or from the subject. By default, only casts leading IN the subject are returned.
# Only direct casts are supported. The list is sorted by the date of the cast creation.
# 
# <tt><b>param</b></tt> subjectUri The subject in which the cast leads, identified by UESURI.
# 
# <tt><b>param</b></tt> criteria Object containing the search criteria.
# 
# <tt><b>return</b></tt> List of CastHistoryRecord containing the attributes of cast history record. The list is sorted by the date of the cast creation.
# 
# <tt><b>throws</b></tt> UESCastRTException
# 
# <tt><b>since</b></tt> UES8-18
  def self.getCastHistoryList(subjectUri, criteria = nil)
    subjectUri = Ues::Core::Commons::Uri::UESURI.new(subjectUri).to_java
    criteria = Ues::Core::Role::UESCastGetCastHistoryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESCast.java_class)
    _r = _s.getCastHistoryList(subjectUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESCast
    alias cast_history_list getCastHistoryList
  end
end
