#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# 
# The search criteria specifies which roles to search for, whether to include
# system area in the search and how to return the result set (ordering and
# paging).
# 
# <h3>Query</h3>
# 
# 
# 
# The <code>query</code> attribute specifies which roles to search for as well
# as ordering settings. Syntax rules are same as in case of other paging
# commands. See @see <a href=
# "https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY"
# target="_blank">UESQuery Documentation</a>.
# 
# 
# 
# Some examples of queries are:
# 
# * 
# 
# * <code>name~'director'</code>
# 
# * <code>code='UNI%' AND name~'director' ORDER BY name DESC, code</code>
# 
# * <code>(code='UNI%' AND name~'director') OR name='Universe manager'</code>
# 
# * <code>code='UNI%' AND name~'director' AND stateType='active'</code>
# </ol>
# 
# 
# 
# 
# As can be seen, query looks a bit like SQL query. Fields that can be used for
# narrowing down the search are "name" (representing role name), "code"
# (representing role code) and stateType (representing role state). The query
# is not case-insensitive, exception being the value for "code" field which is
# case-sensitive.
# 
# <h4>Conditions</h4>
# 
# 
# 
# The conditions (e.g. <code>code='UNI%'</code>) can use "=" sign or "~" sign.
# 
# 
# 
# "=" sign is the same as SQL's LIKE operator. This also means that characters
# "%" and "_" are considered as wild-card characters. If it's necessary to find
# role containing such a character, add backslash before these characters.
# 
# 
# 
# "~" sign is used for fulltext queries which are described below. See also
# chapter "Restrictions".
# 
# 
# 
# Values must be enclosed in single quotes. If a single quote or a backslash is
# present in the value, it must be escaped by a backslash character.
# 
# <h4>Fulltext</h4>
# 
# 
# 
# Value used in the condition with "~" sign can contain words, phrases and word
# prefixes. Roles that will be found must contain all given terms, in any
# order, case-insensitively.
# 
# 
# 
# Phrases must be enclosed into double quotes. A term is considered as a word
# prefix, if it ends with '%' character.
# 
# 
# * <code>name~'role\'s director%'</code> - finds "role's directors",
# "A Director of Role's", ...
# 
# * <code>name~'The "James Bond"'</code></li> - finds "The Only James Bond",
# but not "Bond James - the one".
# 
# 
# 
# 
# 
# 
# Note that characters '%' and '"' are considered special, so if they're
# required to be a part of a word, they must be escaped by using backslash
# character.
# <h4>Ordering</h4>
# 
# 
# 
# The query contains also information about ordering which is given in a
# SQL-like syntax (see example #2 at the beginning of the chapter). If ordering
# settings are not given, default order will be used (first by name ascending,
# then by code ascending).
# 
# <h4>Gramatics</h4>
# 
# 
# 
# The query gramatics is like this:
# 
# 
# * query := &lt;group&gt; [ "ORDER BY" &lt;order&gt; ]
# 
# * group := "(" &lt;group&gt; ")" | &lt;group&gt; "AND" &lt;group&gt; |
# &lt;group&gt; "OR" &lt;group&gt; | &lt;condition&gt;
# 
# * condition := &lt;field&gt; &lt;sign&gt; "'" &lt;value&gt; "'"
# 
# * field := "name" | "code"
# 
# * sign := "=" | "~"
# 
# * value := <i>any text with special characters escaped by using backslash
# character</i>
# 
# * order := &lt;orderRule&gt; ("," &lt;orderRule&gt;)*
# 
# * orderRule := &lt;field&gt; [ "ASC" | "DESC" ]
# 
# 
# 
# 
# <h3>Paging</h3>
# 
# 
# 
# Paging settings (<code>pageIndex</code>, <code>pageSize</code>) specify how
# many results to return and from which page to start (0-based). If maximum
# number of results is not given, the command will return maximum number of
# artifacts according to the system settings.
# 
# <h3>Restrictions</h3>
# 
# 
# * Conditions with field "code" can't use "~" sign.
# 
# * When using condition with "=" sign, wild-card ("%" or "_") can be used
# only at the end of the value.
# 
# 
# 
# 
# <tt><b>author</b></tt> uni428
# 
# <tt><b>since</b></tt> UES6-06
class Ues::Core::Role::UESRoleSearchQuery < Ues::Platform::Commons::Lang::UESPagingCriteria

  @dtoValue = nil

  def self.supports(params) #:nodoc:
    if ((params.java_kind_of?Java::cz.ues.core.role.dto.UESRoleSearchQuery) || (params.kind_of?self))
      return true
    elsif (!params.java_kind_of?Hash)
      return false
    end
    params.each do |_k, _v|
      if (!(((_k == :query || _k == :arg0) && ((_v == nil) || (_v.java_kind_of?Java::java.lang.String) || (_v.java_kind_of?String) || (_v.java_kind_of?"".class))) ||
          ((_k == :includeSystemArea || _k == :arg1) && ((_v == nil) || (_v.java_kind_of?TrueClass) || (_v.java_kind_of?FalseClass) || (_v.java_kind_of?Java::java.lang.Boolean))) ||
          ((_k == :recursive || _k == :arg2) && ((_v == nil) || (_v.java_kind_of?TrueClass) || (_v.java_kind_of?FalseClass) || (_v.java_kind_of?Java::java.lang.Boolean))) ||
          ((_k == :pageIndex || _k == :arg3) && ((_v == nil) || (_v.java_kind_of?Fixnum) || (_v.java_kind_of?Float) || (_v.java_kind_of?Java::java.lang.Number))) ||
          ((_k == :pageSize || _k == :arg4) && ((_v == nil) || (_v.java_kind_of?Fixnum) || (_v.java_kind_of?Float) || (_v.java_kind_of?Java::java.lang.Number)))))
        return false
      end
    end
    return true    
  end
  
  # Creates new instance of UESRoleSearchQuery. As parameter is accepted:
  # * Another instance of UESRoleSearchQuery
  # * Instance of Java object cz.ues.core.role.dto.UESRoleSearchQuery
  # * Ruby hash containing some of following parameters:
  #   * query (alias arg0) - String or instance of java.lang.String
  #   * includeSystemArea (alias arg1) - TrueClass, FalseClass or instance of java.lang.Boolean
  #   * recursive (alias arg2) - TrueClass, FalseClass or instance of java.lang.Boolean
  #   * pageIndex (alias arg3) - Fixnum or instance of java.lang.Number
  #   * pageSize (alias arg4) - Fixnum or instance of java.lang.Number
  def initialize(params=nil)
    if (params == nil)
      params = {}
    end
    if (params.java_kind_of?Java::cz.ues.core.role.dto.UESRoleSearchQuery)
      @dtoValue = params
    elsif (params.kind_of?self.class)
      @dtoValue = params.to_java
    elsif (!params.java_kind_of?Hash)
      raise "Type of parameter \"" + params.class.to_s + "\" cannot be used to create new instance of \"" + self.class.to_s + "\"."
    else
      query = nil; includeSystemArea = nil; recursive = nil; pageIndex = nil; pageSize = nil
      params.each do |_k, _v|
        if ((_k == :query || _k == :arg0) && ((_v == nil) || (_v.java_kind_of?Java::java.lang.String) || (_v.java_kind_of?String) || (_v.java_kind_of?"".class)))
          if ((!_v.java_kind_of?Java::java.lang.Object) && (_v.class.method_defined?"to_java")) then _v = _v.to_java end
          query = _v
        elsif ((_k == :includeSystemArea || _k == :arg1) && ((_v == nil) || (_v.java_kind_of?TrueClass) || (_v.java_kind_of?FalseClass) || (_v.java_kind_of?Java::java.lang.Boolean)))
          if ((!_v.java_kind_of?Java::java.lang.Object) && (_v.class.method_defined?"to_java")) then _v = _v.to_java end
          includeSystemArea = _v
        elsif ((_k == :recursive || _k == :arg2) && ((_v == nil) || (_v.java_kind_of?TrueClass) || (_v.java_kind_of?FalseClass) || (_v.java_kind_of?Java::java.lang.Boolean)))
          if ((!_v.java_kind_of?Java::java.lang.Object) && (_v.class.method_defined?"to_java")) then _v = _v.to_java end
          recursive = _v
        elsif ((_k == :pageIndex || _k == :arg3) && ((_v == nil) || (_v.java_kind_of?Fixnum) || (_v.java_kind_of?Float) || (_v.java_kind_of?Java::java.lang.Number)))
          
          pageIndex = _v
        elsif ((_k == :pageSize || _k == :arg4) && ((_v == nil) || (_v.java_kind_of?Fixnum) || (_v.java_kind_of?Float) || (_v.java_kind_of?Java::java.lang.Number)))
          
          pageSize = _v
        else
          if (_k != :query && _k != :arg0 && _k != :includeSystemArea && _k != :arg1 && _k != :recursive && _k != :arg2 && _k != :pageIndex && _k != :arg3 && _k != :pageSize && _k != :arg4)
            raise "Name of parameter \"" + _k.to_s + "\" is not valid for DTO \"" + self.class.to_s + "\"."
          elsif (_v.java_kind_of?Hash)
            raise "Hash parameter \"" + _k.to_s + "\" is not valid for DTO \"" + self.class.to_s + "\". Either Hash type is unsupported on this DTO or the Hash contains invalid attributes."
          else
            raise "Type \"" + _v.class.to_s + "\" of parameter \"" + _k.to_s + "\" is not valid for DTO \"" + self.class.to_s + "\"."
          end
        end
      end
      if (query != nil || includeSystemArea != nil || recursive != nil || pageIndex != nil || pageSize != nil)
        @dtoValue = Java::cz.ues.core.role.dto.UESRoleSearchQuery.new(query, includeSystemArea, recursive, pageIndex, pageSize)
      else
        @dtoValue = Java::cz.ues.core.role.dto.UESRoleSearchQuery.new(query, includeSystemArea, recursive, pageIndex, pageSize)
      end
    end
  end


  # :stopdoc:
  def getQuery()
    _r = @dtoValue.getQuery()
    
    return _r
  end
  alias query getQuery
  # :startdoc:

  # :stopdoc:
  def setQuery(query)
    if ((!query.java_kind_of?Java::java.lang.Object) && (query.class.method_defined?"to_java")) then query = query.to_java end
    _r = @dtoValue.setQuery(query)
    
    return _r
  end
  alias query= setQuery
  # :startdoc:

  # :stopdoc:
  def isIncludeSystemArea()
    _r = @dtoValue.isIncludeSystemArea()
    
    return _r
  end
  alias include_system_area? isIncludeSystemArea
  # :startdoc:

  # :stopdoc:
  def setIncludeSystemArea(includeSystemArea)
    if ((!includeSystemArea.java_kind_of?Java::java.lang.Object) && (includeSystemArea.class.method_defined?"to_java")) then includeSystemArea = includeSystemArea.to_java end
    _r = @dtoValue.setIncludeSystemArea(includeSystemArea)
    
    return _r
  end
  alias include_system_area= setIncludeSystemArea
  # :startdoc:

  # :stopdoc:
  def getRecursive()
    _r = @dtoValue.getRecursive()
    
    return _r
  end
  alias recursive getRecursive
  # :startdoc:

  # :stopdoc:
  def setRecursive(recursive)
    if ((!recursive.java_kind_of?Java::java.lang.Object) && (recursive.class.method_defined?"to_java")) then recursive = recursive.to_java end
    _r = @dtoValue.setRecursive(recursive)
    
    return _r
  end
  alias recursive= setRecursive
  # :startdoc:

  # :stopdoc:
  def toString()
    _r = @dtoValue.toString()
    
    return _r
  end
  alias to_string toString
  # :startdoc:

  # Returns java class
  def self.java_class
    return Java::cz.ues.core.role.dto.UESRoleSearchQuery
  end
  
  # Returns instance of cz.ues.core.role.dto.UESRoleSearchQuery
  def to_java
    return @dtoValue
  end

  def to_s
    if (@dtoValue != nil) then return @dtoValue.toString() else return nil end
  end
  
  def inspect #:nodoc:
    if (@dtoValue != nil) then return @dtoValue.toString() else return nil end
  end
end
