#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Security::UESMetaPermission
  private_class_method :new


# The command grants template of permission for the specified template. The template of permission must be specified for concrete
# authority (role, group or implicit group). A own settings data (see UESMetaPermissionGrant#data) can be used for permission
# settings.
# 
# <tt><b>param</b></tt> templateUri UESURI of the template for that the template of permission is granted
# 
# <tt><b>param</b></tt> metaPermission DTO containing attributes of the template of permission
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.grant(templateUri, metaPermission = nil)
    templateUri = Ues::Core::Commons::Uri::UESURI.new(templateUri).to_java
    metaPermission = Ues::Core::Security::Authz::UESMetaPermissionGrant.new(metaPermission).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.grant(templateUri, metaPermission)
    
    return _r
  end

# The command revokes template of permissions for the specified template. The template of permissions must be specified for a concrete
# authority (role, group or implicit group). The command can remove all (see UESMetaPermissionRevoke#all) or part (see
# UESMetaPermissionRevoke#data) of permission settings.
# 
# <tt><b>param</b></tt> templateUri UESURI of the template for that the template of permission is revoked
# 
# <tt><b>param</b></tt> metaPermission DTO containing attributes of the template of permission to revoke
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.revoke(templateUri, metaPermission = nil)
    templateUri = Ues::Core::Commons::Uri::UESURI.new(templateUri).to_java
    metaPermission = Ues::Core::Security::Authz::UESMetaPermissionRevoke.new(metaPermission).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.revoke(templateUri, metaPermission)
    
    return _r
  end

# This command returns a list of authorities who have template of permission on the specified template.
# 
# <tt><b>param</b></tt> templateUri UESURI of the template for that the template of permission are applied
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing the permissions
# 
# <tt><b>return</b></tt> List of DTO with attributes of authorities
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getAuthorityList(templateUri, criteria = nil)
    templateUri = Ues::Core::Commons::Uri::UESURI.new(templateUri).to_java
    criteria = Ues::Core::Security::Authz::UESMetaPermissionGetAuthorityList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.getAuthorityList(templateUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias authority_list getAuthorityList
  end

# This command returns a template of permission settings data for the specified template and authority. The template of permission
# settings is list of pairs: an use case code (access unit or access collection) and a cast level. The list is complete list of the all
# possibles actions. The result is composed from set actions (set by command UESMetaPermission#grant) and from rest of actions
# that are defined in the system catalog.  
#  
# The result is streamed in JSON or CSV. 
#  
# JSON format:
# 
# 
# * key "useCaseCode" - contains codes of use cases (access units or access collections)
# 
# * key "castLevel" - contains cast level value (if it is empty, the settings for this use case is ignored)
# 
# 
# 
# CSV format:
# 
# 
# * the first column - contains codes of use cases (access units or access collections)
# 
# * the second column - contains cast level value (if it is empty, the settings for this use case is ignored)
# 
# 
# 
# Possible cast level values:
# 
# 
# * ASSISTANCE - gives access rights for executive and assistance cast roles
# 
# * EXECUTIVE - gives access rights for executive cast roles
# 
# * GUEST - gives access rights for executive, assistance and guest cast roles
# 
# * REVOKE - removes access rights
# 
# 
# 
# 
# <tt><b>param</b></tt> templateUri UESURI of the template for that the template of permission
# 
# <tt><b>param</b></tt> options DTO containing options for getting template of permission settings data
# 
# <tt><b>return</b></tt> List of DTO with attributes of template of permission
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getAuthorityData(templateUri, options = nil)
    templateUri = Ues::Core::Commons::Uri::UESURI.new(templateUri).to_java
    options = Ues::Core::Security::Authz::UESMetaPermissionGetAuthorityData.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.getAuthorityData(templateUri, options)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias authority_data getAuthorityData
  end

# This command creates meta permission mask for template.
# 
# <tt><b>param</b></tt> templateUri UESURI of the meta artifact where the mask is aggregated.
# 
# <tt><b>param</b></tt> mask DTO containing attributes of the new permission mask
# 
# <tt><b>return</b></tt> UESURI of the new permission mask
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.createMask(templateUri, mask = nil)
    templateUri = Ues::Core::Commons::Uri::UESURI.new(templateUri).to_java
    mask = Ues::Core::Security::Authz::UESMetaPermissionCreateMask.new(mask).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.createMask(templateUri, mask)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias create_mask createMask
  end

# The command deletes the specified permission mask from the system. 
# When the mask is marked as default, the command fails.
# 
# <tt><b>param</b></tt> maskUri UESURI of the permission mask which is about to be deleted
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.deleteMask(maskUri)
    maskUri = Ues::Core::Commons::Uri::UESURI.new(maskUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.deleteMask(maskUri)
    
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias delete_mask deleteMask
  end

# This command returns attributes representing the permission mask specified by the permissionMaskUri parameter.
# 
# <tt><b>param</b></tt> maskUri UESURI of the permission mask
# 
# <tt><b>return</b></tt> DTO containing attributes of the permission mask
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getMaskAttributes(maskUri)
    maskUri = Ues::Core::Commons::Uri::UESURI.new(maskUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.getMaskAttributes(maskUri)
    if (_r != nil) then _r = Ues::Core::Security::Authz::UESMetaPermissionGetMaskAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias mask_attributes getMaskAttributes
  end

# The command returns the complete permission mask settings data. The mask settings is list of pairs an use case code (access unit or
# access collection) and a cast level. The list is complete list of the all possibles actions. The result is composed from set actions
# (set by commands UESMetaPermission#create or UESMetaPermission#setMaskData) and from rest of actions that are defined
# in the system catalog. The result is streamed in JSON or CSV. 
#  
# JSON format:
# 
# 
# * key "useCaseCode" - contains codes of use cases (access units or access collections)
# 
# * key "castLevel" - contains cast level value (if it is empty, the settings for this use case is ignored)
# 
# 
# 
# CSV format:
# 
# 
# * the first column - contains codes of use cases (access units or access collections)
# 
# * the second column - contains cast level value (if it is empty, the settings for this use case is ignored)
# 
# 
# 
# Possible cast level values:
# 
# 
# * ASSISTANCE - gives access rights for executive and assistance cast roles
# 
# * EXECUTIVE - gives access rights for executive cast roles
# 
# * GUEST - gives access rights for executive, assistance and guest cast roles
# 
# * REVOKE - removes access rights
# 
# 
# 
# 
# <tt><b>param</b></tt> maskUri UESURI of the permission mask
# 
# <tt><b>param</b></tt> options DTO containing an options for getting mask settings data.
# 
# <tt><b>return</b></tt> DTO containing the permission mask settings data in a stream.
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getMaskData(maskUri, options = nil)
    maskUri = Ues::Core::Commons::Uri::UESURI.new(maskUri).to_java
    options = Ues::Core::Security::Authz::UESMetaPermissionGetMaskData.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.getMaskData(maskUri, options)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias mask_data getMaskData
  end

# This command returns a list of permission mask that are placed on the specified meta artifact. The list of returned masks could be
# filtered by the name or code. The list is sorted by the name (and codes in case are equal) of a permission mask by default.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact where permission masks are
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing permission masks
# 
# <tt><b>return</b></tt> List of DTO with attributes of permission masks
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getMaskList(metaArtifactUri, criteria = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    criteria = Ues::Core::Security::Authz::UESMetaPermissionGetMaskList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.getMaskList(metaArtifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias mask_list getMaskList
  end

# The command sets new attributes of the specified permission mask.
# 
# <tt><b>param</b></tt> maskUri UESURI of the permission mask which attributes are to be changed
# 
# <tt><b>param</b></tt> mask DTO containing new attributes of the permission mask
# 
# <tt><b>return</b></tt> UESURI of the permission mask
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.setMaskAttributes(maskUri, mask = nil)
    maskUri = Ues::Core::Commons::Uri::UESURI.new(maskUri).to_java
    mask = Ues::Core::Security::Authz::UESMetaPermissionSetMaskAttributes.new(mask).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.setMaskAttributes(maskUri, mask)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias set_mask_attributes setMaskAttributes
  end

# The command stores a permission mask settings. The mask settings is list of pairs an use case code (access unit or access collection)
# and a cast level. For more information see UESMetaPermissionSetMaskData#data.
# 
# <tt><b>param</b></tt> accessRightsMaskUri
# 
# <tt><b>param</b></tt> maskData
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.setMaskData(accessRightsMaskUri, maskData = nil)
    accessRightsMaskUri = Ues::Core::Commons::Uri::UESURI.new(accessRightsMaskUri).to_java
    maskData = Ues::Core::Security::Authz::UESMetaPermissionSetMaskData.new(maskData).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.setMaskData(accessRightsMaskUri, maskData)
    
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias set_mask_data setMaskData
  end

# This command returns a list of system groups that are defined for the specified template or territory.
# 
# <tt><b>param</b></tt> entityUri UESURI of template or territory
# 
# <tt><b>return</b></tt> List of DTO with attributes of system group
# 
# <tt><b>throws</b></tt> UESMetaPermissionRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getSystemGroupList(entityUri, criteria = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    criteria = Ues::Core::Security::Authz::UESMetaPermissionGetSystemGroupList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.UESMetaPermission.java_class)
    _r = _s.getSystemGroupList(entityUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Security::UESMetaPermission
    alias system_group_list getSystemGroupList
  end
end
