class Ues::Core::Security::Session::UESSession

  # Logs user in. As credentials are accepted:
  # * Empty or nil parameter (invokes login dialog on client side)
  # * Full path to file containing credentials (must be in form of property file containing keys accessCode1, accessCode2 and optional securityRealm)
  # * Relative path to file (in UES home) containing credentials (must be in form of property file containing keys accessCode1, accessCode2 and optional securityRealm)
  # * Access Code 1 and Access Code 2
  # * Security Realm, Access Code 1 and Access Code 2
  #
  # <tt><b>since</b></tt> UES8-08
  def self.login(*credentials)
    return UESLogin.login(*credentials)
  end

  # Checks if we are already logged in.
  #
  # <tt><b>since</b></tt> UES8-08
  def self.isLoggedIn
    return UESLogin.isLoggedIn
  end

  class << Ues::Core::Security::Session::UESSession
    alias logged_in? isLoggedIn
  end

  # Logout user.
  #
  # <tt><b>since</b></tt> UES8-08
  def self.logout
    return UESLogin.logout
  end

end
