#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::AppBox
  private_class_method :new

  BEAPPBOX_CODE = Java::cz.ues.core.sysc.AppBox::BEAPPBOX_CODE #:nodoc:

  # URI of AppBox business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_APPBOX = Java::cz.ues.core.sysc.AppBox::BETYPE_APPBOX


# Creates a new application box. The command creates a new application box in a specified location. At the very least meta artifact must
# be specified in AppBoxCreate DTO. Competent role for the application box will be selected as the most suitable according to
# specified container and meta artifact(executive/authorized role with connected interface), or can be also specified in
# AppBoxCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where application box will be created.
# 
# <tt><b>param</b></tt> DTO containing attributes of the new application box
# 
# <tt><b>return</b></tt> UESURI of the new application box
# 
# <tt><b>throws</b></tt> AppBoxRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, appBox = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    appBox = Ues::Core::Sysc::AppBoxCreate.new(appBox).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.AppBox.java_class)
    _r = _s.create(locationUri, appBox)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the application box specified by the appBoxUri parameter. The command does not change the
# state of the application box in the system.
# 
# <tt><b>param</b></tt> appBoxUri UESURI of an application box whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the application box attributes
# 
# <tt><b>throws</b></tt> AppBoxRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(appBoxUri)
    appBoxUri = Ues::Core::Commons::Uri::UESURI.new(appBoxUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.AppBox.java_class)
    _r = _s.getAttributes(appBoxUri)
    if (_r != nil) then _r = Ues::Core::Sysc::AppBoxAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::AppBox
    alias attributes getAttributes
  end

# Command for setting attributes of an application box. The command can't modify references to objects like location, competent role and
# so on.
# 
# <tt><b>param</b></tt> appBoxUri UESURI of the application box whose attributes are to be changed
# 
# <tt><b>param</b></tt> appBox DTO containing new attributes the application box
# 
# <tt><b>return</b></tt> UESURI of the application box
# 
# <tt><b>throws</b></tt> AppBoxRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(appBoxUri, appBox = nil)
    appBoxUri = Ues::Core::Commons::Uri::UESURI.new(appBoxUri).to_java
    appBox = Ues::Core::Sysc::AppBoxSetAttributes.new(appBox).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.AppBox.java_class)
    _r = _s.setAttributes(appBoxUri, appBox)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::AppBox
    alias set_attributes setAttributes
  end

# This command returns a list of entries (artifacts or shortcuts) enlisted in the specified application box. Only entries listed exactly
# in the specified application boxes are considered (so subordinate application boxes are not considered). The command does not return
# all entries, only a sublist. The list of returned entries could be filtered by the name or code. The list is sorted by the name (and
# codes in case are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the filtering or
# these attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> appBoxUri UESURI of the application box from where entries (artifacts or shortcuts) are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing entries Available parameters are: AppBoxEntryAttributes#name name and
# AppBoxEntryAttributes#code code.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing entries of the appBoxUri (artifacts or shortcuts).
  def self.getEntryList(appBoxUri, criteria = nil)
    appBoxUri = Ues::Core::Commons::Uri::UESURI.new(appBoxUri).to_java
    criteria = Ues::Core::Sysc::AppBoxGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.AppBox.java_class)
    _r = _s.getEntryList(appBoxUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::AppBox
    alias entry_list getEntryList
  end

  # :stopdoc:
  def self.getAppList(appBoxUri, criteria = nil)
    appBoxUri = Ues::Core::Commons::Uri::UESURI.new(appBoxUri).to_java
    criteria = Ues::Core::Sysc::AppBoxGetAppList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.AppBox.java_class)
    _r = _s.getAppList(appBoxUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::AppBox
    alias app_list getAppList
  end
  # :startdoc:
end
