#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::MetaUseCaseRealization
  private_class_method :new

  BE_META_USE_CASE_REALIZATION_CODE = Java::cz.ues.core.sysc.MetaUseCaseRealization::BE_META_USE_CASE_REALIZATION_CODE #:nodoc:

  # URI of UseCaseRealization business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_META_USE_CASE_REALIZATION = Java::cz.ues.core.sysc.MetaUseCaseRealization::BETYPE_META_USE_CASE_REALIZATION


# Copy a meta use case realization. The command creates a new meta use case realization according to specified source meta use case
# realization in a specified location. At the very least location meta use case realization and name must be specified in
# MetaUseCaseRealizationCopy DTO. Competent role for the new meta use case realization copy will be selected as the most suitable
# according to specified container and role (executive/authorized role with connected interface), or can be also specified in
# MetaUseCaseRealizationCopy DTO.
# 
# <tt><b>param</b></tt> sourceMetaArtifactUri UESURI of the meta use case realization which will be copied.
# 
# <tt><b>param</b></tt> metaUseCaseRealization DTO containing attributes of the new meta use case realization copy.
# 
# <tt><b>return</b></tt> UESURI of the new meta use case realization.
# 
# <tt><b>throws</b></tt> MetaUseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.copy(sourceMetaArtifactUri, metaUseCaseRealization = nil)
    sourceMetaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(sourceMetaArtifactUri).to_java
    metaUseCaseRealization = Ues::Core::Sysc::MetaUseCaseRealizationCopy.new(metaUseCaseRealization).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.MetaUseCaseRealization.java_class)
    _r = _s.copy(sourceMetaArtifactUri, metaUseCaseRealization)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the meta use case realization specified by the metaUseCaseRealizationUri parameter. Only
# basic attributes can be returned by this command. The command does not change the state of the meta artifact in the system.
# 
# <tt><b>param</b></tt> metaUseCaseRealizationUri UESURI of a meta use case realization whose attributes are returned.
# 
# <tt><b>return</b></tt> DTO containing the meta use case realization attributes.
# 
# <tt><b>throws</b></tt> MetaUseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(metaUseCaseRealizationUri)
    metaUseCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(metaUseCaseRealizationUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.MetaUseCaseRealization.java_class)
    _r = _s.getAttributes(metaUseCaseRealizationUri)
    if (_r != nil) then _r = Ues::Core::Sysc::MetaUseCaseRealizationAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::MetaUseCaseRealization
    alias attributes getAttributes
  end

# The command for setting attributes of a specified meta use case realization. The command can't modify references to object like
# storage, competent role and so on.
# 
# <tt><b>param</b></tt> metaUseCaseRealizationUri UESURI of the meta use case realization.
# 
# <tt><b>param</b></tt> metaUseCaseRealization DTO containing new attributes of the meta use case realization.
# 
# <tt><b>return</b></tt> UESURI of the meta use case realization.
# 
# <tt><b>throws</b></tt> MetaUseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(metaUseCaseRealizationUri, metaUseCaseRealization = nil)
    metaUseCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(metaUseCaseRealizationUri).to_java
    metaUseCaseRealization = Ues::Core::Sysc::MetaUseCaseRealizationSetAttributes.new(metaUseCaseRealization).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.MetaUseCaseRealization.java_class)
    _r = _s.setAttributes(metaUseCaseRealizationUri, metaUseCaseRealization)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::MetaUseCaseRealization
    alias set_attributes setAttributes
  end
end
