#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::UseCase
  private_class_method :new

  BEUSECASE_CODE = Java::cz.ues.core.sysc.UseCase::BEUSECASE_CODE #:nodoc:

  # URI of UseCaseRealization business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_USECASE = Java::cz.ues.core.sysc.UseCase::BETYPE_USECASE


# The command creates a use case in a specified meta artifact.
# 
# <tt><b>param</b></tt> metaArtifactUri URI of the meta artifact where the use case is aggregated.
# 
# <tt><b>param</b></tt> useCase DTO containing attributes of the new use case
# 
# <tt><b>return</b></tt> URI of the new use case
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(metaArtifactUri, useCase = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    useCase = Ues::Core::Sysc::UseCaseCreate.new(useCase).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.create(metaArtifactUri, useCase)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command deletes the specified use case from the system
# 
# <tt><b>param</b></tt> useCaseUri URI of the use case which is about to be deleted
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.delete(useCaseUri)
    useCaseUri = Ues::Core::Commons::Uri::UESURI.new(useCaseUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.delete(useCaseUri)
    
    return _r
  end

# This command returns attributes representing the use case specified by the useCaseUri parameter.
# 
# <tt><b>param</b></tt> useCaseUri URI of the use case
# 
# <tt><b>return</b></tt> DTO containing attributes of the use case
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(useCaseUri)
    useCaseUri = Ues::Core::Commons::Uri::UESURI.new(useCaseUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.getAttributes(useCaseUri)
    if (_r != nil) then _r = Ues::Core::Sysc::UseCaseAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCase
    alias attributes getAttributes
  end

# The command sets attributes on specified use case according to useCaseUri.
# 
# <tt><b>param</b></tt> useCaseUri URI of the use case
# 
# <tt><b>param</b></tt> useCase DTO containing new attributes of the use case
# 
# <tt><b>return</b></tt> URI of the use case
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(useCaseUri, useCase = nil)
    useCaseUri = Ues::Core::Commons::Uri::UESURI.new(useCaseUri).to_java
    useCase = Ues::Core::Sysc::UseCaseSetAttributes.new(useCase).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.setAttributes(useCaseUri, useCase)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCase
    alias set_attributes setAttributes
  end

# The command sets options of the specified use case.
# 
# <tt><b>param</b></tt> useCaseUri URI of the use case
# 
# <tt><b>param</b></tt> options DTO containing the options data for setting use case options.
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setOptions(useCaseUri, options = nil)
    useCaseUri = Ues::Core::Commons::Uri::UESURI.new(useCaseUri).to_java
    options = Ues::Core::Sysc::UseCaseSetOptions.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.setOptions(useCaseUri, options)
    
    return _r
  end
  class << Ues::Core::Sysc::UseCase
    alias set_options setOptions
  end

# The command returns options of the specified use case.
# 
# <tt><b>param</b></tt> useCaseUri URI of the use case
# 
# <tt><b>param</b></tt> options DTO containing an options for getting use case options.
# 
# <tt><b>return</b></tt> DTO containing the use case options in a stream.
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getOptions(useCaseUri, options = nil)
    useCaseUri = Ues::Core::Commons::Uri::UESURI.new(useCaseUri).to_java
    options = Ues::Core::Sysc::UseCaseGetOptions.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.getOptions(useCaseUri, options)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCase
    alias options getOptions
  end

# Returns list of the use cases that are defined on the specified meta artifact. The list of returned use cases could be filtered by the
# name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and codes
# in case are equal) of an use case by default.
# 
# <tt><b>param</b></tt> metaArtifactUri URI of the meta artifact uri
# 
# <tt><b>param</b></tt> criteria DTO containing the criteria for listing use cases.
# 
# <tt><b>return</b></tt> List of DTO with attributes of use cases
# 
# <tt><b>throws</b></tt> UseCaseRTException
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES7-10
  def self.getUseCaseList(metaArtifactUri, criteria = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    criteria = Ues::Core::Sysc::UseCaseGetUseCaseList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.getUseCaseList(metaArtifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCase
    alias use_case_list getUseCaseList
  end

  # :stopdoc:
  def self.getUseCaseUrlPath(useCaseUri)
    useCaseUri = Ues::Core::Commons::Uri::UESURI.new(useCaseUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCase.java_class)
    _r = _s.getUseCaseUrlPath(useCaseUri)
    
    return _r
  end
  class << Ues::Core::Sysc::UseCase
    alias use_case_url_path getUseCaseUrlPath
  end
  # :startdoc:
end
