#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>deprecated</b></tt> Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase.
class Ues::Core::Sysc::UseCaseRealization
  private_class_method :new

  BE_USE_CASE_REALIZATION_CODE = Java::cz.ues.core.sysc.UseCaseRealization::BE_USE_CASE_REALIZATION_CODE #:nodoc:

  # URI of UseCaseRealization business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE__USE_CASE_REALIZATION = Java::cz.ues.core.sysc.UseCaseRealization::BETYPE__USE_CASE_REALIZATION


# The command creates a use case realization in a specified meta model. At the very least meta artifact must be specified in
# UseCaseRealizationCreate DTO. Competent role for the new use case realization will be selected as the most suitable according
# to specified container and meta artifact (executive/authorized role with connected interface), or can be also specified in
# UseCaseRealizationCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the meta model where the use case realization will be created.
# 
# <tt><b>param</b></tt> useCaseRealization DTO containing attributes of the new use case realization.
# 
# <tt><b>return</b></tt> UESURI of the new use case realization.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, useCaseRealization = nil)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.create] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    useCaseRealization = Ues::Core::Sysc::UseCaseRealizationCreate.new(useCaseRealization).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.create(locationUri, useCaseRealization)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command deletes the specified use case realization from the system. The command fails when the specified use case realization is
# referenced by some use case. The use case realization is deleted even if it contains a locked sheet or attachment.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization which is about to be deleted.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.delete(useCaseRealizationUri)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.delete] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.delete(useCaseRealizationUri)
    
    return _r
  end

# This command returns attributes representing the use case realization specified by the useCaseRealizationUri parameter.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization.
# 
# <tt><b>return</b></tt> DTO containing attributes of the use case realization.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(useCaseRealizationUri)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.getAttributes] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.getAttributes(useCaseRealizationUri)
    if (_r != nil) then _r = Ues::Core::Sysc::UseCaseRealizationAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCaseRealization
    alias attributes getAttributes
  end

# The command for setting attributes of a specified use case realization. The command can't modify references to object like storage,
# competent role and so on.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization.
# 
# <tt><b>param</b></tt> useCaseRealization DTO containing new attributes of the use case.
# 
# <tt><b>return</b></tt> UESURI of the use case realization.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(useCaseRealizationUri, useCaseRealization = nil)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.setAttributes] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    useCaseRealization = Ues::Core::Sysc::UseCaseRealizationSetAttributes.new(useCaseRealization).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.setAttributes(useCaseRealizationUri, useCaseRealization)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCaseRealization
    alias set_attributes setAttributes
  end

# The command returns options of the specified use case.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization.
# 
# <tt><b>param</b></tt> options DTO containing an options for getting use case realization options.
# 
# <tt><b>return</b></tt> UESStreamHandler containing the use case realization options in a stream.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getOptions(useCaseRealizationUri, options = nil)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.getOptions] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    options = Ues::Core::Sysc::UseCaseRealizationGetOptions.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.getOptions(useCaseRealizationUri, options)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCaseRealization
    alias options getOptions
  end

# The command sets options of the specified use case realization.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization.
# 
# <tt><b>param</b></tt> options DTO containing the options data for setting use case realization options.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setOptions(useCaseRealizationUri, options = nil)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.setOptions] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    options = Ues::Core::Sysc::UseCaseRealizationSetOptions.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.setOptions(useCaseRealizationUri, options)
    
    return _r
  end
  class << Ues::Core::Sysc::UseCaseRealization
    alias set_options setOptions
  end

# Returns list of the use cases that are connected to the specified use case realization. The list of returned use cases could be
# filtered by the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the
# name (and codes in case are equal) of an use case by default. See Also: <a>UES Query Documentation</a>.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization for which the connected use cases are to be listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing connected use cases.
# 
# <tt><b>return</b></tt> List of DTO representing use cases which are connected to the specified use case realization.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm? &SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES7-10
  def self.getUseCaseList(useCaseRealizationUri, criteria = nil)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.getUseCaseList] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    criteria = Ues::Core::Sysc::UseCaseRealizationGetUseCaseList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.getUseCaseList(useCaseRealizationUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCaseRealization
    alias use_case_list getUseCaseList
  end

# The command returns content of first attachment which is used as data for use case realization.
# 
# <tt><b>param</b></tt> useCaseRealizationUri UESURI of the use case realization.
# 
# <tt><b>return</b></tt> UESStreamHandler containing the first attachment content in a stream.
# 
# <tt><b>throws</b></tt> UseCaseRealizationRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getData(useCaseRealizationUri)
    warn "[DEPRECATED: Ues::Core::Sysc::UseCaseRealization.getData] Since UES8-04 replaced by cz.ues.core.sysc.VisualUseCase."
    useCaseRealizationUri = Ues::Core::Commons::Uri::UESURI.new(useCaseRealizationUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.UseCaseRealization.java_class)
    _r = _s.getData(useCaseRealizationUri)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::UseCaseRealization
    alias data getData
  end
end
