#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::VisualUseCase
  private_class_method :new

  BE_VISUAL_USE_CASE_CODE = Java::cz.ues.core.sysc.VisualUseCase::BE_VISUAL_USE_CASE_CODE #:nodoc:

  # URI of VisualUseCase business entity.
# 
# <tt><b>since</b></tt> UES8-04
  BETYPE_VISUAL_USE_CASE = Java::cz.ues.core.sysc.VisualUseCase::BETYPE_VISUAL_USE_CASE


# The command creates a visual use case in a specified meta model. At the very least meta artifact must be specified in
# VisualUseCaseCreate DTO. Competent role for the new visual use case will be selected as the most suitable according to
# specified container and meta artifact (executive/authorized role with connected interface), or can be also specified in
# VisualUseCaseCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the meta model where the visual use case will be created.
# 
# <tt><b>param</b></tt> visualUseCase DTO containing attributes of the new visual use case.
# 
# <tt><b>return</b></tt> UESURI of the new visual use case.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.create(locationUri, visualUseCase = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    visualUseCase = Ues::Core::Sysc::VisualUseCaseCreate.new(visualUseCase).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.create(locationUri, visualUseCase)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command deletes the specified visual use case from the system. The command fails when the specified visual use case is referenced
# by some use case. The visual use case is deleted even if it contains a locked sheet or attachment.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case which is about to be deleted.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.delete(visualUseCaseUri)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.delete(visualUseCaseUri)
    
    return _r
  end

# This command returns attributes representing the visual use case specified by the visualUseCaseUri parameter.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case.
# 
# <tt><b>return</b></tt> DTO containing attributes of the visual use case.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getAttributes(visualUseCaseUri)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.getAttributes(visualUseCaseUri)
    if (_r != nil) then _r = Ues::Core::Sysc::VisualUseCaseAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias attributes getAttributes
  end

# The command for setting attributes of a specified visual use case. The command can't modify references to object like storage,
# competent role and so on.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case.
# 
# <tt><b>param</b></tt> visualUseCase DTO containing new attributes of the use case.
# 
# <tt><b>return</b></tt> UESURI of the visual use case.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.setAttributes(visualUseCaseUri, visualUseCase = nil)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    visualUseCase = Ues::Core::Sysc::VisualUseCaseSetAttributes.new(visualUseCase).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.setAttributes(visualUseCaseUri, visualUseCase)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias set_attributes setAttributes
  end

# The command returns options of the specified use case.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case.
# 
# <tt><b>param</b></tt> options DTO containing an options for getting visual use case options.
# 
# <tt><b>return</b></tt> UESStreamHandler containing the visual use case options in a stream.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getOptions(visualUseCaseUri, options = nil)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    options = Ues::Core::Sysc::VisualUseCaseGetOptions.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.getOptions(visualUseCaseUri, options)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias options getOptions
  end

# The command sets options of the specified visual use case.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case.
# 
# <tt><b>param</b></tt> options DTO containing the options data for setting visual use case options.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.setOptions(visualUseCaseUri, options = nil)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    options = Ues::Core::Sysc::VisualUseCaseSetOptions.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.setOptions(visualUseCaseUri, options)
    
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias set_options setOptions
  end

# Returns list of the use cases that are connected to the specified visual use case. The list of returned use cases could be filtered by
# the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and
# codes in case are equal) of an use case by default. See Also: <a>UES Query Documentation</a>.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case for which the connected use cases are to be listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing connected use cases.
# 
# <tt><b>return</b></tt> List of DTO representing use cases which are connected to the specified visual use case.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm? &SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES8-04
  def self.getUseCaseList(visualUseCaseUri, criteria = nil)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    criteria = Ues::Core::Sysc::VisualUseCaseGetUseCaseList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.getUseCaseList(visualUseCaseUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias use_case_list getUseCaseList
  end

# The command returns content of first attachment which is used as data for visual use case.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case.
# 
# <tt><b>return</b></tt> UESStreamHandler containing the first attachment content in a stream.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getData(visualUseCaseUri)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.getData(visualUseCaseUri)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias data getData
  end

# The command exports a visual use case to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is
# why it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case to export
# 
# <tt><b>param</b></tt> visualUseCase DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.export(visualUseCaseUri, visualUseCase = nil)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    visualUseCase = Ues::Core::Sysc::VisualUseCaseExport.new(visualUseCase).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.export(visualUseCaseUri, visualUseCase)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported visual use case.
# 
# <tt><b>param</b></tt> visualUseCaseUri UESURI of the visual use case we want to get the exported file from.
# 
# <tt><b>param</b></tt> visualUseCase DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported visual use case.
# 
# <tt><b>throws</b></tt> VisualUseCaseRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(visualUseCaseUri, visualUseCase = nil)
    visualUseCaseUri = Ues::Core::Commons::Uri::UESURI.new(visualUseCaseUri).to_java
    visualUseCase = Ues::Core::Sysc::VisualUseCaseGetExportData.new(visualUseCase).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.VisualUseCase.java_class)
    _r = _s.getExportData(visualUseCaseUri, visualUseCase)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::VisualUseCase
    alias export_data getExportData
  end
end
