#--
# This code is automatically generated, do not modify the content !!!
#++
# UESActivityCondition is a service that provides operations related to conditions of activity templates and activity instances.
# 
# <tt><b>since</b></tt> UES8-07
class Ues::Core::Workflow::UESActivityCondition
  private_class_method :new


# Creates a new activity condition for the specified activity template or activity instance. Type of the activity condition
# must be always specified. Then, according to this type, following parameters must be specified too:
# 
# - For time condition, the parameter dateOfFulfilling must be specified
# - For artifact state condition, the parameter artifactStateTemplateUri must be specified
# - For activity state condition, the parameter activityStateTemplateUri must be specified
# - For composed condition, the parameters expression and conditionList must be specified
# 
# <tt><b>param</b></tt> entityUri UESURI of the entity for which will be the activity condition created. The activity or activity template can be entered as the command main entity.
# 
# <tt><b>param</b></tt> activityCondition Object containing attributes of the new activity condition.
# 
# <tt><b>return</b></tt> Identifier (conditionCode) of the new activity condition.
# 
# <tt><b>throws</b></tt> UESActivityConditionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.create(entityUri, activityCondition = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    activityCondition = Ues::Core::Workflow::UESActivityConditionCreate.new(activityCondition).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityCondition.java_class)
    _r = _s.create(entityUri, activityCondition)
    
    return _r
  end

# Deletes the specified activity condition.
# 
# <tt><b>param</b></tt> entityUri UESURI of the entity (activity instance or activity template) the activity condition, which is to be deleted, is connected to.
# 
# <tt><b>param</b></tt> activityCondition Identifier of the activity condition which is to be deleted.
# 
# <tt><b>throws</b></tt> UESActivityConditionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.delete(entityUri, activityCondition = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    activityCondition = Ues::Core::Workflow::UESActivityConditionGetAttributes.new(activityCondition).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityCondition.java_class)
    _r = _s.delete(entityUri, activityCondition)
    
    return _r
  end

# Returns a list of activity conditions for the specified entity. Activity template or activity instance can be entered
# as the mentioned entity. The list is sorted by the attribute conditionCode of activity conditions by default.
# 
# <tt><b>param</b></tt> entityUri UESURI of the entity (activity template or activity instance) whose list of activity conditions is to be returned.
# 
# <tt><b>param</b></tt> criteria Object containing paging criteria.
# 
# <tt><b>return</b></tt> Returns list of activity conditions according to the entered entity. Each item in the list contains UESActivityConditionAttributes.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank"> UESQuery
# Documentation.</a>
# 
# <tt><b>throws</b></tt> UESActivityConditionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getActivityConditionList(entityUri, criteria = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    criteria = Ues::Core::Workflow::UESActivityConditionGetActivityConditionList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityCondition.java_class)
    _r = _s.getActivityConditionList(entityUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityCondition
    alias activity_condition_list getActivityConditionList
  end
end
