#--
# This code is automatically generated, do not modify the content !!!
#++
# UESActivityTemplate is a service that provides operations related to activity templates.
# 
# <tt><b>since</b></tt> UES8-07
class Ues::Core::Workflow::UESActivityTemplate
  private_class_method :new

  BE_ACTIVITY_TEMPLATE_CODE = Java::cz.ues.core.workflow.UESActivityTemplate::BE_ACTIVITY_TEMPLATE_CODE #:nodoc:

  # URI of UESActivityTemplate business entity.
  BETYPE_ACTIVITY_TEMPLATE = Java::cz.ues.core.workflow.UESActivityTemplate::BETYPE_ACTIVITY_TEMPLATE


# Creates a new activity template either on the specified meta artifact or on the specified activity template
# (in the case of creating a new template for subactivities). At least, its future name and type have to be
# specified in this command.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the meta artifact (or activity template) the new activity template should be created on.
# 
# <tt><b>param</b></tt> activityTemplate Object containing attributes of the new activity template.
# 
# <tt><b>return</b></tt> UESURI of the new activity template
# 
# <tt><b>throws</b></tt> UESActivityTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.create(parentNodeUri, activityTemplate = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    activityTemplate = Ues::Core::Workflow::UESActivityTemplateCreate.new(activityTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityTemplate.java_class)
    _r = _s.create(parentNodeUri, activityTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes of the specified activity template.
# 
# <tt><b>param</b></tt> activityTemplateUri UESURI of an activity template whose attributes are to be returned.
# 
# <tt><b>return</b></tt> Object with attributes of the activity template.
# 
# <tt><b>throws</b></tt> UESActivityTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getAttributes(activityTemplateUri)
    activityTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityTemplate.java_class)
    _r = _s.getAttributes(activityTemplateUri)
    if (_r != nil) then _r = Ues::Core::Workflow::UESActivityTemplateAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityTemplate
    alias attributes getAttributes
  end

# Sets basic attributes of the specified activity template. This command cannot modify the type.
# 
# <tt><b>param</b></tt> activityTemplateUri UESURI of the activity template whose attributes are to be modified.
# 
# <tt><b>param</b></tt> activityTemplate Object containing new attributes of the activity template.
# 
# <tt><b>return</b></tt> UESURI of the modified activity template.
# 
# <tt><b>throws</b></tt> UESActivityTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.setAttributes(activityTemplateUri, activityTemplate = nil)
    activityTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityTemplateUri).to_java
    activityTemplate = Ues::Core::Workflow::UESActivityTemplateSetAttributes.new(activityTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityTemplate.java_class)
    _r = _s.setAttributes(activityTemplateUri, activityTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityTemplate
    alias set_attributes setAttributes
  end

# Deletes the activity template. It cannot be deleted in case there is an action or condition that contains
# this template or if the template has already been used for creating another template. Also, it is not possible
# to delete generic templates.
# 
# <tt><b>param</b></tt> activityTemplateUri UESURI of the activity template which is to be deleted.
# 
# <tt><b>throws</b></tt> UESActivityTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.delete(activityTemplateUri)
    activityTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityTemplate.java_class)
    _r = _s.delete(activityTemplateUri)
    
    return _r
  end

# Returns a list of activity templates of the specified meta artifact according to the entered criteria.
# Criteria are defined using query. The list of returned activity state templates can be filtered and sorted
# by the name, code, type, blockTimeInCalendar, allowExecutiveRoleChange and allowSubactivities (or by combinations
# of those attributes). The list is sorted by the attribute name (and by code in case names are equal)
# of activity templates by default. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> metaArtifactUri UESURI of the meta artifact whose activity templates are to be listed.
# 
# <tt><b>param</b></tt> criteria Object containing attributes of the activity templates that are to be listed.
# 
# <tt><b>return</b></tt> List of Objects representing activity templates including templates for subactivities (the same objects as in the command getAttributes).
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank"> UESQuery
# Documentation.</a>
# 
# <tt><b>throws</b></tt> UESActivityTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getActivityTemplateList(metaArtifactUri, criteria = nil)
    metaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(metaArtifactUri).to_java
    criteria = Ues::Core::Workflow::UESActivityTemplateGetActivityTemplateList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityTemplate.java_class)
    _r = _s.getActivityTemplateList(metaArtifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityTemplate
    alias activity_template_list getActivityTemplateList
  end
end
