#--
# This code is automatically generated, do not modify the content !!!
#++
# Manager for working with model of UESActivity.
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Workflow::UESActivityManager
  private_class_method :new


# Gets activity model attributes specified by activityModelUri.
# 
# <tt><b>param</b></tt> activityModelUri UESURI of activity model
# 
# <tt><b>return</b></tt> DTO with attributes of activity model
# 
# <tt><b>since</b></tt> UES6-00
  def self.getModelAttributes(activityModelUri)
    activityModelUri = Ues::Core::Commons::Uri::UESURI.new(activityModelUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.getModelAttributes(activityModelUri)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias model_attributes getModelAttributes
  end

# Gets activity model attributes specified by activityUri.
# 
# <tt><b>param</b></tt> activityUri UESURI of activity model
# 
# <tt><b>return</b></tt> UESURI of activity model
# 
# <tt><b>since</b></tt> UES6-00
  def self.getModelUri(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.getModelUri(activityUri)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias model_uri getModelUri
  end

# Gets activity state attributes.
# 
# <tt><b>param</b></tt> activityUri UES-URI of activity
# 
# <tt><b>return</b></tt> activity state entity
# 
# <tt><b>since</b></tt> UES6-00
  def self.getStateAttributes(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.getStateAttributes(activityUri)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias state_attributes getStateAttributes
  end

# Gets subactivities.
# 
# <tt><b>param</b></tt> activityUri UESURI of activity model
# 
# <tt><b>return</b></tt> UESURI of subactivities
# 
# <tt><b>since</b></tt> UES6-00
  def self.getSubactivities(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.getSubactivities(activityUri)
    if (_r != nil) then _t = []; _r.to_a.each do |_e|; if (_e != nil) then _e = Ues::Core::Commons::Uri::UESURI.new(_e) end; _t << _e; end; _r = _t; end;
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias subactivities getSubactivities
  end

# Checks if activity is root activity.
# 
# <tt><b>param</b></tt> activityUri UESURI of activity
# 
# <tt><b>return</b></tt> <code>true</code> if activity is root activity, otherwise
# <code>false</code>
# 
# <tt><b>since</b></tt> UES6-00
  def self.isRootActivity(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.isRootActivity(activityUri)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias is_root_activity isRootActivity
  end

# Checks if activityUri is UEUSRI of model
# 
# <tt><b>param</b></tt> activityUri
# 
# <tt><b>return</b></tt> 
# 
# <tt><b>since</b></tt> 4.9.2012 (Administrator)
  def self.isModel(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.isModel(activityUri)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias is_model isModel
  end

# Returns true if the specified UESURI belongs to an activity template or false, if it's an activity
# model or instance. Otherwise, it throws the specified exception.
# 
# <tt><b>param</b></tt> entityUri UESURI of an object to be checked out
# 
# <tt><b>param</b></tt> exceptionCode the code of exception to be thrown if entityUri is none of activity template, model or instance
# 
# <tt><b>return</b></tt> true for an activity template, false for an activity model or instance
# 
# <tt><b>throws</b></tt> UESWorkflowModuleRTException if entityUri has an unexpected type
  def self.isActivityTemplateOrModel(entityUri, exceptionCode = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    if ((!exceptionCode.java_kind_of?Java::java.lang.Object) && (exceptionCode.class.method_defined?"to_java")) then exceptionCode = exceptionCode.to_java end
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.isActivityTemplateOrModel(entityUri, exceptionCode)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias is_activity_template_or_model isActivityTemplateOrModel
  end

# Returns UESURI of an activity model that can be used for authorization.
# 
# <tt><b>param</b></tt> entityUri UESURI of an activity instance or activity model
# 
# <tt><b>param</b></tt> exceptionCode the code of exception to be thrown if entityUri is neither of activity model nor activity instance
# 
# <tt><b>return</b></tt> UESURI of the specified activity model or of the model of the specified activity instance
# 
# <tt><b>throws</b></tt> UESWorkflowModuleRTException if entityUri has an unexpected type
  def self.getActivityModelUri(entityUri, exceptionCode = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    if ((!exceptionCode.java_kind_of?Java::java.lang.Object) && (exceptionCode.class.method_defined?"to_java")) then exceptionCode = exceptionCode.to_java end
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.spi.UESActivityManager.java_class)
    _r = _s.getActivityModelUri(entityUri, exceptionCode)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityManager
    alias activity_model_uri getActivityModelUri
  end
end
